/*
 * Created on Jan 24, 2004
 * @author Junaed Sattar 
 *
 */
package org.junaed.comp644;

import java.awt.HeadlessException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JApplet;
import javax.swing.JOptionPane;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * Main applet for Freeman Chain Coding demonstration
 * @author Muser-01
 * 
 */
public class ProjectMain extends JApplet implements ActionListener, ChangeListener {

	private javax.swing.JPanel jContentPane = null;
	private javax.swing.JPanel jPanel = null;
	private javax.swing.JButton jButton = null;
	private javax.swing.JCheckBox jCheckBox = null;
	private org.junaed.comp644.CurvePanel curvePanel = null;
	private javax.swing.JSlider jSlider = null;
	private javax.swing.JButton jButton1 = null;
	private javax.swing.JCheckBox jCheckBox1 = null;
	private javax.swing.JPanel jPanel1 = null;
	private javax.swing.JPanel jPanel2 = null;
	private javax.swing.JCheckBox jCheckBox2 = null;
	private javax.swing.JCheckBox jCheckBox3 = null;
	/**
	 * @throws java.awt.HeadlessException
	 */
	public ProjectMain() throws HeadlessException {
		super();
		init();
	}

	/* 
	 * Event Handler for the controlpanel
	 * Just the Button to delete all points for now
	 */
	public void actionPerformed(ActionEvent arg0) 
	{		
		if( arg0.getSource()==jButton )
		{
			curvePanel.setClear(true);
			curvePanel.repaint();	
			return;
		}
		if( arg0.getSource()==jButton1 )
		{
			Object[] type = {"Square Quantization", 
							 "Circular Quantization",
							 "Grid-Intersect Quantization"};
			String s = (String)JOptionPane.showInputDialog(
			                    this,
			                    "Choose quantization type:\n",
			                    "Customized Dialog",
			                    JOptionPane.INFORMATION_MESSAGE,
			                    null,
			                    type,
			                    "Square Quantization");			
			if (s==null) return;			
			if ( s.equals("Square Quantization")) curvePanel.setNType(0);
			else
				if ( s.equals("Circular Quantization")) curvePanel.setNType(1);
				else
					if ( s.equals("Grid-Intersect Quantization")) curvePanel.setNType(2);			
			curvePanel.getMeshPoints();
			curvePanel.repaint();			
			return;
		}
	}

	public static void main(String[] args) {
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	public void init() {
		this.setContentPane(getJContentPane());
		this.setSize(700, 600);
		this.setLocation(0, 0);
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) 
		{
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.add(getJPanel(), java.awt.BorderLayout.SOUTH);
			jContentPane.add(getCurvePanel(), java.awt.BorderLayout.CENTER);
			jContentPane.setBackground(java.awt.Color.black);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if(jPanel == null) {
			jPanel = new javax.swing.JPanel();
			jPanel.setLayout(new java.awt.FlowLayout());
			jPanel.add(getJPanel2(), null);
			jPanel.add(getJPanel1(), null);
			jPanel.add(getJButton1(), null);
			jPanel.add(getJButton(), null);
			jPanel.setBackground(new java.awt.Color(204,204,204));
		}
		return jPanel;
	}
	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButton() {
		if(jButton == null) {
			jButton = new javax.swing.JButton();
			jButton.setText("Clear");
			jButton.setMnemonic(java.awt.event.KeyEvent.VK_C);
			jButton.setName("clearButton");
			jButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/Wallpaper5.png")));
			jButton.addActionListener(this);
		}
		return jButton;
	}
	/**
	 * This method initializes jCheckBox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private javax.swing.JCheckBox getJCheckBox() {
		if(jCheckBox == null) {
			jCheckBox = new javax.swing.JCheckBox();
			jCheckBox.setText("Show Grid");
			jCheckBox.setMnemonic(java.awt.event.KeyEvent.VK_G);
			jCheckBox.setName("GridCheck");				
			jCheckBox.addChangeListener(this);
		}
		return jCheckBox;
	}
	/**
	 * This method initializes curvePanel
	 * 
	 * @return org.junaed.comp644.CurvePanel
	 */
	private org.junaed.comp644.CurvePanel getCurvePanel() {
		if(curvePanel == null) {
			curvePanel = new org.junaed.comp644.CurvePanel();
			curvePanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
		}
		return curvePanel;
	}

	/* (non-Javadoc)
	 * @see javax.swing.event.ChangeListener#stateChanged(javax.swing.event.ChangeEvent)
	 */
	public void stateChanged(ChangeEvent arg0) 
	{		
		/*
		 * Control panel  
		 */
		if( arg0.getSource() == jCheckBox )
		{
			curvePanel.setShowGrid(jCheckBox.isSelected());
			curvePanel.repaint();
			return;
		}
		if( arg0.getSource() == jCheckBox1 )
				{
					curvePanel.setShowCells(jCheckBox1.isSelected());
					curvePanel.repaint();
					return;
				}
		if( arg0.getSource() == jCheckBox2 )
				{
					curvePanel.setDynamic(jCheckBox2.isSelected());
					curvePanel.repaint();
					return;
				}
		if( arg0.getSource() == jCheckBox3 )
				{
					curvePanel.setShowCurve(jCheckBox3.isSelected());
					curvePanel.repaint();
					return;
				}
		if( arg0.getSource() == jSlider )
		{
			int nVal = jSlider.getValue();
			curvePanel.setNResolution(nVal);
			curvePanel.repaint();
			System.out.println("Slider is at :"+nVal);			
		}
	}
	/**
	 * This method initializes jSlider
	 * 
	 * @return javax.swing.JSlider
	 */
	private javax.swing.JSlider getJSlider() {
		if(jSlider == null) {
			jSlider = new javax.swing.JSlider();
			jSlider.setMajorTickSpacing(20);
			jSlider.setMinimum(20);
			jSlider.setName("GridSlider");
			jSlider.setToolTipText("adjust grid resolution");
			jSlider.setValue(20);
			jSlider.setPaintTicks(true);
			jSlider.setSnapToTicks(false);
			jSlider.addChangeListener(this);			
		}
		return jSlider;
	}
	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButton1() {
		if(jButton1 == null) {
			jButton1 = new javax.swing.JButton();
			jButton1.setText("Mesh Points");
			jButton1.setMnemonic(java.awt.event.KeyEvent.VK_M);
			jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/Atom.png")));
			jButton1.addActionListener(this);
		}
		return jButton1;
	}
	/* (non-Javadoc)
	 * @see java.applet.Applet#getAppletInfo()
	 */
	public String getAppletInfo() 
	{		
		String strInfo="Applet Programmed by Junaed Sattar"+"\n"+
						"Project for Pattern Recognition class by Professor Godfried Touissant.";
		return strInfo; 
	}

	/**
	 * This method initializes jCheckBox1
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private javax.swing.JCheckBox getJCheckBox1() {
		if(jCheckBox1 == null) {
			jCheckBox1 = new javax.swing.JCheckBox();
			jCheckBox1.setText("Show Cells");
			jCheckBox1.setMnemonic(java.awt.event.KeyEvent.VK_L);
			jCheckBox1.addChangeListener(this);
		}
		return jCheckBox1;
	}
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel1() {
		if(jPanel1 == null) {
			jPanel1 = new javax.swing.JPanel();
			java.awt.GridLayout layGridLayout1 = new java.awt.GridLayout();
			layGridLayout1.setRows(2);
			layGridLayout1.setColumns(1);
			jPanel1.setLayout(layGridLayout1);
			jPanel1.add(getJCheckBox3(), null);
			jPanel1.add(getJCheckBox(), null);
			jPanel1.add(getJCheckBox1(), null);
		}
		return jPanel1;
	}
	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel2() {
		if(jPanel2 == null) {
			jPanel2 = new javax.swing.JPanel();
			java.awt.GridLayout layGridLayout2 = new java.awt.GridLayout();
			layGridLayout2.setRows(2);
			layGridLayout2.setColumns(1);
			jPanel2.setLayout(layGridLayout2);
			jPanel2.add(getJSlider(), null);
			jPanel2.add(getJCheckBox2(), null);
		}
		return jPanel2;
	}
	/**
	 * This method initializes jCheckBox2
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private javax.swing.JCheckBox getJCheckBox2() {
		if(jCheckBox2 == null) {
			jCheckBox2 = new javax.swing.JCheckBox();
			jCheckBox2.setText("Dynamic Chain Update (SLOW)");
			jCheckBox2.setMnemonic(java.awt.event.KeyEvent.VK_D);
			jCheckBox2.addChangeListener(this);
		}
		return jCheckBox2;
	}
	/**
	 * This method initializes jCheckBox3
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private javax.swing.JCheckBox getJCheckBox3() {
		if(jCheckBox3 == null) {
			jCheckBox3 = new javax.swing.JCheckBox();
			jCheckBox3.setText("Show Curve");
			jCheckBox3.setMnemonic(java.awt.event.KeyEvent.VK_U);
			jCheckBox3.setSelected(true);
			jCheckBox3.addChangeListener(this);
		}
		return jCheckBox3;
	}
}
